CON
_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000

bits = 12                                                             '19.5 KHz sample rate
fbpin = 16                                                             'feedback pin (BPIN)
adcpin = 19                                                            'feedin pin (APIN)

piezoBuzzer  = 20

VAR long value

PUB go | Range
  
  cognew(@asm_entry, @value)                                          'launch assembly program into a COG

  Range := value + 8                                               'Value read in by Sigma-Delta ADC from rangefinder, multiplied to vary WAITCNT significantly
  
  repeat
    waitcnt(40_000_000 + cnt)                                         'wait 1/2 second until updating
    CTRA[30..26] := %00100
    CTRA[5..0] := 20
    FRQA := 112_367
    REPEAT                                                           'Will sound piezo buzzer at a pace corresponding to the value read in from the rangefinder
      !DIRA[20]
      WAITCNT(CLKFREQ /Range + CNT)
    

DAT
' Assembly program
              org
asm_entry     mov       dira,asm_dira                                 'make pins 8 (ADC) and 0 (DAC) outputs
              movs      ctra,#adcpin                                  'POS W/FEEDBACK mode for CTRA
              movd      ctra,#fbpin
              movi      ctra,#%01001_000
              mov       frqa,#1
          
              mov       asm_cnt,cnt                                   'prepare for WAITCNT loop
              add       asm_cnt,asm_cycles
          
:loop         waitcnt   asm_cnt,asm_cycles                            'wait for next CNT value
              mov       asm_sample,phsa                               'capture PHSA and get difference
              sub       asm_sample,asm_old
              add       asm_old,asm_sample
              wrlong    asm_sample, par                               'write the value to main memory
              jmp       #:loop                                        'wait for next sample period
' Data
asm_cycles    long      |< bits - 1                                   'sample time
asm_dira      long      |< fbpin                                      'output mask
asm_cnt       res       1
asm_old       res       1
asm_sample    res       1